     /*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.evasion.client.secure.booktravel;

import com.evasion.common.Constante;
import com.evasion.common.Utils;
import com.evasion.ejb.local.BookTravelManagerLocal;
import com.evasion.ejb.local.UserAuthServiceLocal;
import com.evasion.entity.booktravel.RoadMap;
import com.evasion.entity.booktravel.exception.BookTravelServiceException;
import com.evasion.entity.content.Comment;
import com.evasion.entity.security.User;
import java.io.Serializable;
import java.util.Map;
import java.util.logging.Level;
import javax.annotation.PostConstruct;
import javax.ejb.EJB;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.RequestScoped;
import javax.faces.component.UICommand;
import javax.faces.component.html.HtmlPanelGroup;
import javax.faces.context.FacesContext;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 *
 * @author sebastien
 */
@ManagedBean
@RequestScoped
public class IndexRoadmapCtrl implements Serializable {

    /***
     * serialVersionUID.
     */
    private static final long serialVersionUID = 1L;
    /**
     * LOGGER.
     */
    private static final Logger LOGGER = LoggerFactory.getLogger(
            IndexRoadmapCtrl.class);
    @EJB
    private BookTravelManagerLocal bookTravelEJB;
    @EJB
    private UserAuthServiceLocal userEJB;
    private Comment commentaireNew = new Comment();
    private Long idRoadMap;
    private RoadMap roadMap;
    private HtmlPanelGroup panelAjout;
    private UICommand lienAjout;

    @PostConstruct
    public void init() throws Exception {
        LOGGER.debug("Init de la page d'index d'un bookTravel");
        final Map params = FacesContext.getCurrentInstance().
                getExternalContext().getRequestParameterMap();
        String id = (String) params.get("id");
        String idFormulaire = (String) params.get("idRoadMap");

        if (!Utils.isEmpty(idFormulaire) && idRoadMap == null) {
            idRoadMap = Long.parseLong(idFormulaire);
        } else if (!Utils.isEmpty(id) && idRoadMap == null) {

            idRoadMap = Long.parseLong(id);
        }
        if (idRoadMap != null) {
            try {
                // Force la récupération de la feuille de route.
                this.getRoadMap();
            }
            catch (BookTravelServiceException ex) {
                java.util.logging.Logger.getLogger(IndexRoadmapCtrl.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }

    /**
     * Affiche le panel d'ajout d'un commentaire.
     * @return <code>Constante.SUCCESS_ACTION</code>;
     */
    public String viewPanelAjout() {
        lienAjout.setRendered(false);
        panelAjout.setRendered(true);
        try {
            // Force la récupération de la feuille de route.
            this.getRoadMap();
        }
        catch (BookTravelServiceException ex) {
            java.util.logging.Logger.getLogger(IndexRoadmapCtrl.class.getName()).log(Level.SEVERE, null, ex);
        }
        return Constante.SUCCESS_ACTION;
    }

    /**
     *
     * @return <code>Constante.SUCCESS_ACTION</code>;
     */
    public final String annulAjout() {
        lienAjout.setRendered(true);
        panelAjout.setRendered(false);
        try {
            // Force la récupération de la feuille de route.
            this.getRoadMap();
        }
        catch (BookTravelServiceException ex) {
            java.util.logging.Logger.getLogger(IndexRoadmapCtrl.class.getName()).log(Level.SEVERE, null, ex);
        }
        return Constante.SUCCESS_ACTION;
    }

    /**
     *
     * @return <code>Constante.SUCCESS_ACTION</code>;
     */
    public final String validerAjout() throws BookTravelServiceException {
        lienAjout.setRendered(true);
        panelAjout.setRendered(false);
        //  roadMap.getContribution().getId();
        bookTravelEJB.createCommentOnRoadMap(this.getRoadMap(), commentaireNew);
        return Constante.SUCCESS_ACTION;
    }

    /**
     * Renvoi la feuille de route.
     * @return feuille de route.
     */
    public RoadMap getRoadMap() throws BookTravelServiceException {
        if (idRoadMap != null) {
            this.roadMap = bookTravelEJB.findRoadMapById(this.idRoadMap);
        }
        return this.roadMap;
    }

    /**
     * Renvoi le lien d'ajout d'un commentaire.
     * @return lien d'ajout d'un commentaire;
     */
    public UICommand getLienAjout() {
        return lienAjout;
    }

    public void setLienAjout(UICommand lienAjout) {
        this.lienAjout = lienAjout;
    }

    /**
     * Renvoi de panel d'ajout.
     * @return panel d'ajout;
     */
    public final HtmlPanelGroup getPanelAjout() {
        return panelAjout;
    }

    /**
     * Setter du panel d'ajout.
     * @param panelAjout panel d'ajout;
     */
    public final void setPanelAjout(HtmlPanelGroup panelAjout) {
        this.panelAjout = panelAjout;
    }

    public Long getIdRoadMap() {
        return idRoadMap;
    }

    public void setIdRoadMap(Long idRoadMap) {
        this.idRoadMap = idRoadMap;
    }

    public Comment getCommentaireNew() {
        return commentaireNew;
    }

    public void setCommentaireNew(Comment commentaireNew) {
        this.commentaireNew = commentaireNew;
    }
}
